;peach bomber

!button = $10		;button to press to do attack (default: R)
!buttonram = $18	;should either be 16 or 18. look in the RAM map for more info

!charframe = $0E	;$13E0 frame to use for attack (default: kick object)

!risesfx = $0F		;sfx when you are rising (default: spin jump)
!risesfxbnk = $1DF9|!addr	;sound bank for sfx above
!rise = $18		;time it takes to rise up before going forward
!risespeed = $FF	;rise Y speed. lower = faster unless it's below 80

!forward = $0F		;time to go forward
!xspeed = $40		;speed

!wait = $28		;time to wait in the air before being able to reuse the attack

!crashsfx = $09		;sfx when you crash into a wall (default: bullet bill blast)
!crashsfxbnk = $1DFC|!addr	;sound bank for sfx above
!yknock = $08		;Vertical knockback speed when you crash
!xknock = $20		;horizontal knockback speed when you crash into a wall

!hacharam = $0E85|!addr	;flags. dont change
!hacharam2 = $0E86|!addr	;timer. dont change

-
STZ !hacharam
STZ !hacharam2
RTS

bomber:
LDA $71
CMP #$02
BCS -
LDA $1470|!addr
ORA $73
ORA $74
ORA $75
ORA $1891|!addr
ORA $187A|!addr
ORA $1493|!addr
BNE -

LDA !hacharam
AND #$03
BEQ .init
DEC : LSR
BNE .wait
BCS .forward

.rise
STZ $7B
LDA #!risespeed
STA $7D
LDA #$01
STA $140D|!addr
LDA #!risesfx
STA !risesfxbnk
DEC !hacharam2
BNE +
INC !hacharam
LDA #!forward
STA !hacharam2
STZ $140D|!addr
+
JMP .end

.init
LDA !buttonram
AND #!button
BEQ +
LDA $76
LSR : ROR : INC
STA !hacharam
LDA #!rise
STA !hacharam2
+
JMP .end

.wait
LDA $77
AND #$04
BNE +
DEC !hacharam2
BNE ++
+
STZ !hacharam
++
JMP .end

.forward
LDA #$02
STA $1490|!addr
STA $149B|!addr
STA $18D3|!addr
LDA #!charframe
STA $13E0|!addr
LDA !hacharam
ASL
LDA #!xspeed
BCS +
EOR #$FF
INC A
+
STA $7B
STZ $7D
STZ $76
ROL $76
LDA $77
AND #$03
BNE .crash
DEC !hacharam2
BNE .end
STZ $7B
LDA #!wait
STA !hacharam2
INC !hacharam
STZ $18D2|!addr
STZ $1490|!addr
STZ $149B|!addr
STZ $18D3|!addr
BRA .end

.crash
LDA #!crashsfx
STA !crashsfxbnk
LDY #$03
-
LDA $17C0|!addr,y
BEQ +
DEY : BPL -
INY
+
LDA #$02
STA $17C0|!addr,y
LDA $D1
CLC : ADC #$04
STA $17C8|!addr,y
LDA $D3
ADC #$10
STA $17C4|!addr,y
LDA #$08
STA $17CC|!addr,y
LDA #!yknock
STA $7D
LDA #!xknock
LDY $76
BEQ +
EOR #$FF
INC A
+
STA $7B
LDA #!wait
STA !hacharam2
INC !hacharam

.end
RTS