;smb2 hi-jump

!floattime = $40	;how long floating lasts before falling

!floatram = $0E89|!addr	;flags. dont change
!floatram2 = $0E8A|!addr	;timer. dont change

float:
LDA $19
CMP #$02
BEQ .clear
LDA $71
CMP #$05
BCS .clear
LDA $74
ORA $75
ORA $1891|!addr
ORA $187A|!addr
ORA $1493|!addr
BNE .clear

LDA !floatram
BEQ .init
DEC : LSR
BNE .wait
BCS .float

.jump
LDA $77
AND #$04
BNE .clear
LDA $16
AND #$80
BNE +
LDA $7D
BMI .end
LDA $15
AND #$80
BEQ .end
+
INC !floatram
LDA #!floattime
STA !floatram2
BRA .end

.init
LDA $7D
BEQ .clear
BPL .clear
INC !floatram
BRA .end

.float
LDA $15
AND #$80
BEQ +
JSR .yspeedrt
DEC !floatram2
BNE .end
+
INC !floatram
BRA .end

.wait
LDA $77
AND #$04
BEQ .end

.clear
STZ !floatram
STZ !floatram2

.end
RTS

.yspeedrt
LDA $14
LSR #4
AND #$01
TAX
PHB : PHK : PLB
LDA .yspeed,x
PLB
STA $7D
RTS

.yspeed
db $FD,$03